<script setup>
import { onBeforeUnmount, onMounted, ref } from "vue";

definePageMeta({
  layout: "error-server",
});

const countdown = ref(10);
let countdownInterval = null;

async function reloadPage() {
  const { data } = await useAPIFetch("/health-check");
  if (data.value !== undefined) {
    navigateTo("/");
  } else {
    // Restart the countdown after the check
    startCountdown();
  }
}

function startCountdown() {
  countdown.value = 10; // Reset countdown to 10
  clearInterval(countdownInterval); // Clear any existing intervals
  countdownInterval = setInterval(() => {
    countdown.value--;
    if (countdown.value === 0) {
      clearInterval(countdownInterval); // Clear interval on reaching zero
      reloadPage(); // Call reloadPage when countdown is finished
    }
  }, 1000);
}

function manualReload() {
  clearInterval(countdownInterval); // Clear interval on manual reload
  reloadPage(); // Call reloadPage immediately
}

onMounted(() => {
  startCountdown(); // Start the countdown when the component is mounted
});

onBeforeUnmount(() => {
  clearInterval(countdownInterval); // Clear interval when component is unmounted
});
</script>

<template>
  <div class="text-center w-100">
    <img
      src="/img/madbot_down.png"
      alt=""
      style="width: 300px"
    >
    <h1>The server is currently unavailable</h1>
    <p>Please try again later. If the problem persists, please contact support</p>
    <v-btn class="mt-4" @click="manualReload">
      Refresh
      <v-progress-circular
        :model-value="(countdown / 10) * 100"
        class="ms-2"
        size="20"
      />
    </v-btn>
  </div>
</template>
